#Created by J.T.B. Overvelde
#2015/07/07
#http://www.overvelde.com
#CREATED IN ABAQUS VERSION 6.11-1.

from part import *
from material import *
from section import *
from assembly import *
from step import *
from interaction import *
from load import *
from mesh import *
from optimization import *
from job import *
from sketch import *
from visualization import *
from connectorBehavior import *

#from AbaqusScriptFunc import NamesModel
#from AbaqusScriptFunc import PeriodicBound
Mdb()
execfile('AbaqusScriptFunc.py')

##################################################################################
#CREATE PART
##################################################################################
mdb.models['Model-1'].ConstrainedSketch(name='__profile__', sheetSize=200.0)
mdb.models['Model-1'].sketches['__profile__'].rectangle(point1=(0.0, 0.0), 
    point2=(1.0, 2.0))
mdb.models['Model-1'].Part(dimensionality=TWO_D_PLANAR, name='Part-1', type=
    DEFORMABLE_BODY)
mdb.models['Model-1'].parts['Part-1'].BaseShell(sketch=
    mdb.models['Model-1'].sketches['__profile__'])
del mdb.models['Model-1'].sketches['__profile__']

mdb.models['Model-1'].parts['Part-1'].HoleFromEdges(diameter=0.6, distance1=0.5
    , distance2=0.5, edge1=mdb.models['Model-1'].parts['Part-1'].edges.findAt(((0.0,1.0,0.0),))[0], 
    edge2=mdb.models['Model-1'].parts['Part-1'].edges.findAt(((0.5,2.0,0.0),))[0])
mdb.models['Model-1'].parts['Part-1'].HoleFromEdges(diameter=0.6, distance1=0.5
    , distance2=0.5, edge1=mdb.models['Model-1'].parts['Part-1'].edges.findAt(((0.0,1.0,0.0),))[0], 
    edge2=mdb.models['Model-1'].parts['Part-1'].edges.findAt(((0.5,0.0,0.0),))[0])

##################################################################################
#DEFINE MATERIAL AND SECTION 
##################################################################################
mdb.models['Model-1'].Material(name='Material-1')
mdb.models['Model-1'].materials['Material-1'].Elastic(table=((1.0, 0.3), ))
mdb.models['Model-1'].HomogeneousSolidSection(material='Material-1', name=
    'Section-1', thickness=None)
mdb.models['Model-1'].parts['Part-1'].SectionAssignment(offset=0.0, 
    offsetField='', offsetType=MIDDLE_SURFACE, region=Region(
    faces=mdb.models['Model-1'].parts['Part-1'].faces), sectionName='Section-1', thicknessAssignment=
    FROM_SECTION)

##################################################################################
#SEED PART
##################################################################################
mdb.models['Model-1'].parts['Part-1'].seedPart(deviationFactor=0.1, 
    minSizeFactor=0.1, size=0.1)
mdb.models['Model-1'].parts['Part-1'].setMeshControls(elemShape=TRI, regions=
    mdb.models['Model-1'].parts['Part-1'].faces)
mdb.models['Model-1'].parts['Part-1'].setElementType(elemTypes=(ElemType(
    elemCode=CPE8R, elemLibrary=STANDARD), ElemType(elemCode=CPE6M, 
    elemLibrary=STANDARD, secondOrderAccuracy=OFF, distortionControl=DEFAULT)), 
    regions=(mdb.models['Model-1'].parts['Part-1'].faces, ))
mdb.models['Model-1'].parts['Part-1'].generateMesh()

##################################################################################
#ASSEMBLE
##################################################################################
mdb.models['Model-1'].rootAssembly.DatumCsysByDefault(CARTESIAN)
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Instance-1', 
    part=mdb.models['Model-1'].parts['Part-1'])

##################################################################################
#CREATE PERIODIC BOUNDARY CONDITIONS
##################################################################################
mdb.models['Model-1'].rootAssembly.Set(edges=(
    mdb.models['Model-1'].rootAssembly.instances['Instance-1'].edges,), name='PerBound')

(CoorFixNode,NameRef1, NameRef2)=PeriodicBound2D(mdb,'Model-1','PerBound',[(1.0,0.0),(0.0,2.0)],)

##################################################################################
#CREATE STEP AND APPLY BC
##################################################################################
mdb.models['Model-1'].StaticStep(name='Step-1', nlgeom=ON, previous='Initial')
#Apply boundary conditions on reference nodes
DefMat=[(0.5,UNSET),(UNSET,UNSET)]
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Step-1', 
    distributionType=UNIFORM, fieldName='', fixed=OFF, localCsys=None, name=
    'BC-REF-1', region=Region(referencePoints=(
    mdb.models['Model-1'].rootAssembly.instances[NameRef1].referencePoints[1], 
    )), u1=DefMat[0][0], u2=DefMat[0][1], ur3=UNSET)
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Step-1', 
    distributionType=UNIFORM, fieldName='', fixed=OFF, localCsys=None, name=
    'BC-REF-2', region=Region(referencePoints=(
    mdb.models['Model-1'].rootAssembly.instances[NameRef2].referencePoints[1], 
    )), u1=DefMat[1][0], u2=DefMat[1][1], ur3=UNSET)
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Step-1', 
    distributionType=UNIFORM, fieldName='', fixed=OFF, localCsys=None, name=
    'BC-FIXNODE', region=Region(
    nodes=mdb.models['Model-1'].rootAssembly.instances['Instance-1'].nodes.getByBoundingSphere(center=CoorFixNode, radius=0.001)), u1=0.0, u2=0.0, ur3=UNSET)
##################################################################################
#JOB AND RUN
##################################################################################
mdb.Job(atTime=None, contactPrint=OFF, description='', echoPrint=OFF, 
    explicitPrecision=SINGLE, getMemoryFromAnalysis=True, historyPrint=OFF, 
    memory=90, memoryUnits=PERCENTAGE, model='Model-1', modelPrint=OFF, 
    multiprocessingMode=DEFAULT, name='Job-1', nodalOutputPrecision=SINGLE, 
    numCpus=1, queue=None, scratch='', type=ANALYSIS, userSubroutine='', 
    waitHours=0, waitMinutes=0)
mdb.jobs['Job-1'].submit(consistencyChecking=OFF)


