#Created by J.T.B. Overvelde
#2015/07/07
#http://www.overvelde.com
#CREATED IN ABAQUS VERSION 6.11-1.

from part import *
from material import *
from section import *
from assembly import *
from step import *
from interaction import *
from load import *
from mesh import *
from optimization import *
from job import *
from sketch import *
from visualization import *
from connectorBehavior import *

Mdb()
execfile('AbaqusScriptFunc.py')

##################################################################################
#CREATE PART
##################################################################################
mdb.models['Model-1'].ConstrainedSketch(name='__profile__', sheetSize=200.0)
mdb.models['Model-1'].sketches['__profile__'].rectangle(point1=(0.0, 0.0), 
    point2=(0.5, 0.5))
mdb.models['Model-1'].Part(dimensionality=THREE_D, name='Part-2', type=
    DEFORMABLE_BODY)
mdb.models['Model-1'].parts['Part-2'].BaseSolidExtrude(depth=0.5, sketch=
    mdb.models['Model-1'].sketches['__profile__'])
del mdb.models['Model-1'].sketches['__profile__']

mdb.models['Model-1'].parts['Part-2'].HoleThruAllFromEdges(diameter=0.5, 
    distance1=0.0, distance2=0.0, edge1=
    mdb.models['Model-1'].parts['Part-2'].edges[0], edge2=
    mdb.models['Model-1'].parts['Part-2'].edges[10], plane=
    mdb.models['Model-1'].parts['Part-2'].faces[4], planeSide=SIDE1)
mdb.models['Model-1'].parts['Part-2'].HoleThruAllFromEdges(diameter=0.5, 
    distance1=0.0, distance2=0.0, edge1=
    mdb.models['Model-1'].parts['Part-2'].edges[13], edge2=
    mdb.models['Model-1'].parts['Part-2'].edges[12], plane=
    mdb.models['Model-1'].parts['Part-2'].faces[4], planeSide=SIDE1)
mdb.models['Model-1'].parts['Part-2'].HoleThruAllFromEdges(diameter=0.5, 
    distance1=0.0, distance2=0.0, edge1=
    mdb.models['Model-1'].parts['Part-2'].edges[15], edge2=
    mdb.models['Model-1'].parts['Part-2'].edges[10], plane=
    mdb.models['Model-1'].parts['Part-2'].faces[5], planeSide=SIDE1)

mdb.models['Model-1'].parts['Part-2'].seedPart(deviationFactor=0.1, 
    minSizeFactor=0.1, size=0.15)
mdb.models['Model-1'].parts['Part-2'].setMeshControls(elemShape=TET, regions=
    mdb.models['Model-1'].parts['Part-2'].cells, technique=FREE)
mdb.models['Model-1'].parts['Part-2'].setElementType(elemTypes=(ElemType(
    elemCode=C3D20R, elemLibrary=STANDARD), ElemType(elemCode=C3D15, 
    elemLibrary=STANDARD), ElemType(elemCode=C3D10, elemLibrary=STANDARD)), 
    regions=(mdb.models['Model-1'].parts['Part-2'].cells, ))
mdb.models['Model-1'].parts['Part-2'].generateMesh()
mdb.models['Model-1'].parts['Part-2'].PartFromMesh(copySets=True, name=
    'Part-2-mesh')
mdb.models['Model-1'].Part(compressFeatureList=ON, mirrorPlane=XYPLANE, name=
    'Part-3-mesh', objectToCopy=
    mdb.models['Model-1'].parts['Part-2-mesh'])
mdb.models['Model-1'].Part(compressFeatureList=ON, mirrorPlane=YZPLANE, name=
    'Part-4-mesh', objectToCopy=
    mdb.models['Model-1'].parts['Part-2-mesh'])
mdb.models['Model-1'].Part(compressFeatureList=ON, mirrorPlane=XYPLANE, name=
    'Part-5-mesh', objectToCopy=
    mdb.models['Model-1'].parts['Part-4-mesh'])
mdb.models['Model-1'].Part(compressFeatureList=ON, mirrorPlane=XZPLANE, name=
    'Part-6-mesh', objectToCopy=
    mdb.models['Model-1'].parts['Part-2-mesh'])
mdb.models['Model-1'].Part(compressFeatureList=ON, mirrorPlane=XYPLANE, name=
    'Part-7-mesh', objectToCopy=
    mdb.models['Model-1'].parts['Part-6-mesh'])
mdb.models['Model-1'].Part(compressFeatureList=ON, mirrorPlane=YZPLANE, name=
    'Part-8-mesh', objectToCopy=
    mdb.models['Model-1'].parts['Part-6-mesh'])
mdb.models['Model-1'].Part(compressFeatureList=ON, mirrorPlane=XYPLANE, name=
    'Part-9-mesh', objectToCopy=
    mdb.models['Model-1'].parts['Part-8-mesh'])

#Assembly
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Part-2-mesh-1', 
    part=mdb.models['Model-1'].parts['Part-2-mesh'])
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Part-3-mesh-1', 
    part=mdb.models['Model-1'].parts['Part-3-mesh'])
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Part-4-mesh-1', 
    part=mdb.models['Model-1'].parts['Part-4-mesh'])
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Part-5-mesh-1', 
    part=mdb.models['Model-1'].parts['Part-5-mesh'])
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Part-6-mesh-1', 
    part=mdb.models['Model-1'].parts['Part-6-mesh'])
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Part-7-mesh-1', 
    part=mdb.models['Model-1'].parts['Part-7-mesh'])
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Part-8-mesh-1', 
    part=mdb.models['Model-1'].parts['Part-8-mesh'])
mdb.models['Model-1'].rootAssembly.Instance(dependent=ON, name='Part-9-mesh-1', 
    part=mdb.models['Model-1'].parts['Part-9-mesh'])
mdb.models['Model-1'].rootAssembly.InstanceFromBooleanMerge(domain=MESH, 
    instances=(mdb.models['Model-1'].rootAssembly.instances['Part-2-mesh-1'], 
    mdb.models['Model-1'].rootAssembly.instances['Part-3-mesh-1'], 
    mdb.models['Model-1'].rootAssembly.instances['Part-4-mesh-1'], 
    mdb.models['Model-1'].rootAssembly.instances['Part-5-mesh-1'], 
    mdb.models['Model-1'].rootAssembly.instances['Part-6-mesh-1'], 
    mdb.models['Model-1'].rootAssembly.instances['Part-7-mesh-1'], 
    mdb.models['Model-1'].rootAssembly.instances['Part-8-mesh-1'], 
    mdb.models['Model-1'].rootAssembly.instances['Part-9-mesh-1']), mergeNodes=
    BOUNDARY_ONLY, name='Part-1', nodeMergingTolerance=1e-06, 
    originalInstances=SUPPRESS)

##################################################################################
#DEFINE MATERIAL AND SECTION 
##################################################################################
mdb.models['Model-1'].Material(name='Material-1')
mdb.models['Model-1'].materials['Material-1'].Elastic(table=((1.0, 0.3), ))
mdb.models['Model-1'].HomogeneousSolidSection(material='Material-1', name=
    'Section-1', thickness=None)
mdb.models['Model-1'].parts['Part-1'].SectionAssignment(offset=0.0, 
    offsetField='', offsetType=MIDDLE_SURFACE, region=Region(
    elements=mdb.models['Model-1'].parts['Part-1'].elements), sectionName='Section-1', 
    thicknessAssignment=FROM_SECTION)

##################################################################################
#CREATE PERIODIC BOUNDARY CONDITIONS
##################################################################################
mdb.models['Model-1'].rootAssembly.Set(nodes=(
    mdb.models['Model-1'].rootAssembly.instances['Part-1-1'].nodes,), name='PerBound')

(CoorFixNode,NameRef1, NameRef2,NameRef3)=PeriodicBound3D(mdb,'Model-1','PerBound',[(1.0,0.0,0.0),(0.0,1.0,0.0),(0.0,0.0,1.0)],)

##################################################################################
#CREATE STEP AND APPLY BC
##################################################################################
mdb.models['Model-1'].StaticStep(name='Step-1', nlgeom=ON, previous='Initial')
#Apply boundary conditions on reference nodes
DefMat=[(0.2,0.0,0.0),(0.0,UNSET,0.0), (0.0,0.0,0.1)]
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Step-1', 
    distributionType=UNIFORM, fieldName='', fixed=OFF, localCsys=None, name=
    'BC-REF-1', region=Region(referencePoints=(
    mdb.models['Model-1'].rootAssembly.instances[NameRef1].referencePoints[1], 
    )), u1=DefMat[0][0], u2=DefMat[0][1], u3=DefMat[0][2], ur1=UNSET,ur2=UNSET,ur3=UNSET)
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Step-1', 
    distributionType=UNIFORM, fieldName='', fixed=OFF, localCsys=None, name=
    'BC-REF-2', region=Region(referencePoints=(
    mdb.models['Model-1'].rootAssembly.instances[NameRef2].referencePoints[1], 
    )), u1=DefMat[1][0], u2=DefMat[1][1], u3=DefMat[1][2], ur1=UNSET,ur2=UNSET,ur3=UNSET)
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Step-1', 
    distributionType=UNIFORM, fieldName='', fixed=OFF, localCsys=None, name=
    'BC-REF-3', region=Region(referencePoints=(
    mdb.models['Model-1'].rootAssembly.instances[NameRef3].referencePoints[1], 
    )), u1=DefMat[2][0], u2=DefMat[2][1], u3=DefMat[2][2], ur1=UNSET,ur2=UNSET,ur3=UNSET)
mdb.models['Model-1'].DisplacementBC(amplitude=UNSET, createStepName='Step-1', 
    distributionType=UNIFORM, fieldName='', fixed=OFF, localCsys=None, name=
    'BC-FIXNODE', region=Region(
    nodes=mdb.models['Model-1'].rootAssembly.instances['Part-1-1'].nodes.getByBoundingSphere(center=CoorFixNode, radius=0.001)), u1=0.0, u2=0.0, u3=0.0, ur1=UNSET, ur2=UNSET,ur3=UNSET)

##################################################################################
#JOB AND RUN
##################################################################################
mdb.Job(atTime=None, contactPrint=OFF, description='', echoPrint=OFF, 
    explicitPrecision=SINGLE, getMemoryFromAnalysis=True, historyPrint=OFF, 
    memory=90, memoryUnits=PERCENTAGE, model='Model-1', modelPrint=OFF, 
    multiprocessingMode=DEFAULT, name='Job-1', nodalOutputPrecision=SINGLE, 
    numCpus=1, queue=None, scratch='', type=ANALYSIS, userSubroutine='', 
    waitHours=0, waitMinutes=0)
mdb.jobs['Job-1'].submit(consistencyChecking=OFF)


